-------------------------------------------
-- DR400 RPMindicator with vibrating needle
--  and automatic lighting
--     Jacques ZAHAR 09/2017
--    
---------------------------------------------------

local needlerpm=0
local rand=1
local val=0
local vibrationlvl=0

-- CUSTOMIZATION VARIABLES ------
display_bezel=true -- affichage du bezel
-- sample Values for a modern single engine (Cessna, Piper, Robin)
frequency=50 -- increase the 40 value to slow down the overall vibrations for "slow running" engines (up to 100 max)
vibmax=80 --beginning of max vibrations in %power
valmax=1.2 -- range of max vibration values
vibmid=30 --beginning of medium vibrations in %power
valmid=2.5
viblow=0.5 -- low idle
vallow=3--0.09

-- sample Values for a WWI Fighter
-- frequency=60 -- increase the 40 value to slow down the overall vibrations for "slow running" engines (up to 100 max)
-- vibmax=90 --beginning of max vibrations in %power
-- valmax=0.5 -- range of max vibration values
-- vibmid=30 --beginning of medium vibrations in %power
-- valmid=1
-- viblow=0.25 -- low idle
-- vallow=2

-- sample values for a WW1 Fighter
-- frequency=70 -- increase the 40 value to slow down the overall vibrations for "slow running" engines (up to 100 max)
-- vibmax=75 --beginning of max vibrations in %power
-- valmax=4 -- range of max vibration values
-- vibmid=40 --beginning of medium vibrations in %power
-- valmid=2.5
-- viblow=0.1 --low idle
-- vallow=3.5
----------------------------------------------

img_thousands = img_add("thousands.png", 156, 265, 145, 145)
img_hundreds = img_add("hundreds.png", 197, 265, 145, 145)
img_tens = img_add("tens.png", 242, 265, 145, 145)
img_hours = img_add("hours.png", 286, 265, 145, 145)
img_minutes = img_add("minutes.png", 328, 265, 145, 145)
img_add_fullscreen("casing.png")
img_needle = img_add_fullscreen ("engine_needle.png")
if display_bezel==true then
	img_add_fullscreen("glass.png")
end
img_rotate(img_needle, 135)

function rotate_cylinder(image_id, val, ceil, exp)
  if (val%1) > ceil then
    img_rotate(image_id, 360 - ( ( (val%1)-ceil) * exp * 360) - (math.floor(val) * 36 )  )
  else
    img_rotate(image_id, 360 - (math.floor(val) * 36 ) )
  end
end

-------------- Variation de luminosité en fonction de l'éclairage---------
D_mask = img_add_fullscreen("masque_Day.png")
K_mask = img_add_fullscreen("masque_Dusk.png")
N_mask = img_add_fullscreen("masque_Night.png")

------------- le code commenté est en cas d'ajout de dial (non utile ici)
-- function callback(turn)
-- print("turn:"..turn)
-- end

-- dial_id = dial_add("airknobjour.png", 100,100,100,100,callback)
-- dial_iddusk = dial_add("airknobdusk.png", 100,100,100,100,callback)
-- dial_idnuit = dial_add("airknobnuit.png", 100,100,100,100,callback)
-- dial_idjour = dial_add("airknobjour.png", 100,100,100,100,callback)

 function new_light_FSX(tension,light,ambiance)
	local panel_lighted= nil
	panel_lighted= tension>14 and light
	img_visible(D_mask,panel_lighted == false and ambiance==1)
	img_visible(K_mask,panel_lighted == false and ambiance==2)
	img_visible(N_mask,panel_lighted == false and ambiance==3)
--  visible(dial_idnuit,panel_lighted == false and ambiance==3)
--  visible(dial_iddusk,panel_lighted == false and ambiance==2)
--  visible(dial_idjour,panel_lighted == false and ambiance==1)
end



fsx_variable_subscribe("ELECTRICAL MAIN BUS VOLTAGE","Volts","LIGHT PANEL","Bool" ,"TIME OF DAY","Enum",new_light_FSX)
---------- Gestion des vibrations aiguille

function vibrate(soundrpm)

	if soundrpm<0.1 then 
	vibrationlvl=0
	else vibrationlvl=soundrpm
	end
end
function vibrate_xp(rpm)

	if rpm<0.1 then 
	vibrationlvl=0
	else vibrationlvl=rpm
	end
end

function timer_callback() -- function called every 40 mseconds,
	rand=-rand -- offset value of the needle, alternatively to the left or to the right 
	--setting up of the amplitude of vibrations depending of the % of sound produced, since engien vibration is not reliable (Change val values to taste!)
	if vibrationlvl>vibmax then  -- high rpm, small amplitude
		val=valmax
	elseif vibrationlvl>vibmid then -- medium range rpm, larger amplitude of needle movements
		val=valmid
	elseif vibrationlvl>viblow then --slow rpm, smaller amplitude of needle movements
			 val=vallow
	else -- engine stopped, no needle movements
			val=0
    end
    
    needlepos=needlerpm+(rand*val) -- calculation of the needle movement
	--print(needlepos)
	-- if  needleairspeed>=150 then
	-- img_rotate(img_neddle, (needlepos-150)*2.15+287)
	-- elseif needleairspeed>=130 then
	-- img_rotate(img_neddle, (needlepos-130)*2.55+236)
	-- elseif needleairspeed>80 then
	-- img_rotate(img_neddle, (needlepos-90)*2.4+140)
	-- img_rotate(img_neddle, (needlepos-80)*2.436+114)
	-- elseif needleairspeed>=40 then
	-- img_rotate(img_neddle, (needlepos-40)*2.25+23)
	-- elseif needleairspeed>=30 then
	-- img_rotate(img_neddle, (needlepos-30)*1.6+7)
	-- else
	-- img_rotate(img_neddle, (needlepos))
	img_rotate(img_needle, needlepos * (295/3490) - 159)
	--end
end

function PT_rpm(rpm)
   	needlerpm = var_cap(rpm[1],200, 3500)
	if needlerpm<300 then needlerpm=300 end
end

function flight_time(time_sec)

    -- minutes
    minutes = time_sec / 60
    img_rotate(img_minutes, 360 - ( (minutes/10) * 360 ) )
    
    -- hours
    hours = minutes / 60
    rotate_cylinder(img_hours,     (hours)     , 0.9835,    6   )
    rotate_cylinder(img_tens,      (hours/10)  , 0.99835,   60  )
    rotate_cylinder(img_hundreds,  (hours/100) , 0.999835,  600 )
    rotate_cylinder(img_thousands, (hours/1000), 0.9999835, 6000)
end

function PT_rpm_FSX(rpm)

	PT_rpm({rpm})
	
end

-- Bus subscribe --
--xpl_dataref_subscribe("sim/cockpit2/engine/indicators/prop_speed_rpm", "FLOAT[8]", PT_rpm)
--xpl_dataref_subscribe("sim/time/hobbs_time", "FLOAT", flight_time)
fsx_variable_subscribe("GENERAL ENG RPM:1", "Rpm", PT_rpm_FSX)
fsx_variable_subscribe("GENERAL ENG ELAPSED TIME:1", "Seconds", flight_time)
-- vibration system based on sound
fsx_variable_subscribe("GENERAL ENG COMBUSTION SOUND PERCENT:1","percent",vibrate)
timer_start(0,frequency,timer_callback) 